* Program............: C:\DBFILES\MISC\MIGRATE1\ADDRESS.FRG
* Date...............: 12-29-94
* Versions...........: dBASE IV, Report 2.0
*
* Notes:
* ------
* Prior to running this procedure with the DO command
* it is necessary use LOCATE because the CONTINUE
* statement is in the main loop.
*
*-- Parameters
PARAMETERS gl_noeject, gl_plain, gl_summary, gc_heading, gc_extra
** The first three parameters are of type Logical.
** The fourth parameter is a string.  The fifth is extra.
PRIVATE _peject, _wrap, ll_heading
ll_heading = .F.

*-- Test for no records found
IF EOF() .OR. .NOT. FOUND()
   RETURN
ENDIF

*-- turn word wrap mode off
_wrap=.F.

IF _plength < (_pspacing * 4 + 1) + (_pspacing + 1) + 2
   SET DEVICE TO SCREEN
   DEFINE WINDOW gw_report FROM 7,17 TO 11,62 DOUBLE
   ACTIVATE WINDOW gw_report
   @ 0,1 SAY "Increase the page length for this report."
   @ 2,1 SAY "Press any key ..."
   x=INKEY(0)
   DEACTIVATE WINDOW gw_report
   RELEASE WINDOW gw_report
   RETURN
ENDIF

_plineno=0          && set lines to zero
*-- NOEJECT parameter
IF gl_noeject
   IF _peject="BEFORE"
      _peject="NONE"
   ENDIF
   IF _peject="BOTH"
      _peject="AFTER"
   ENDIF
ENDIF

*-- Set-up environment
ON ESCAPE DO Prnabort
IF SET("TALK")="ON"
   SET TALK OFF
   gc_talk="ON"
ELSE
   gc_talk="OFF"
ENDIF
gc_space=SET("SPACE")
SET SPACE OFF
gc_time=TIME()      && system time for predefined field
gd_date=DATE()      && system date  "    "    "     "
gl_fandl=.F.        && first and last page flag
gl_prntflg=.T.      && Continue printing flag
gl_widow=.T.        && flag for checking widow bands
gn_length=LEN(gc_heading)  && store length of the HEADING
gn_level=2          && current band being processed
gn_page=_pageno     && grab current page number
gn_pspace=_pspacing && get current print spacing


*-- Set up procedure for page break
gn_atline=_plength - (_pspacing + 1)
ON PAGE AT LINE gn_atline EJECT PAGE

*-- Print Report

PRINTJOB

IF gl_plain
   ON PAGE AT LINE gn_atline DO Pgplain
ELSE
   ON PAGE AT LINE gn_atline DO Pgfoot
ENDIF

DO Pghead

gl_fandl=.T.        && first physical page started

*-- File Loop
DO WHILE FOUND() .AND. .NOT. EOF() .AND. gl_prntflg
   gn_level=0
   *-- Detail lines
   IF gl_summary
      DO Upd_Vars
   ELSE
      DO __Detail
   ENDIF
   gl_widow=.T.         && enable widow checking
   CONTINUE
ENDDO

IF gl_prntflg
   gl_fandl=.F.     && last page finished
   IF _plineno <= gn_atline
      EJECT PAGE
   ENDIF
ELSE
   DO Reset
   RETURN
ENDIF

ON PAGE

ENDPRINTJOB

DO Reset
RETURN
* EOP: C:\DBFILES\MISC\MIGRATE1\ADDRESS.FRG

*-- Update summary fields and/or calculated fields.
PROCEDURE Upd_Vars
RETURN
* EOP: Upd_Vars

*-- Set flag to get out of DO WHILE loop when escape is pressed.
PROCEDURE Prnabort
gl_prntflg=.F.
RETURN
* EOP: Prnabort

PROCEDURE Pghead
PRIVATE ll_heading, ln_width
ll_heading = .T.
ln_width = _rmargin - _lmargin
?
*-- Print HEADING parameter - if it doesn't fit on line one
*-- Value added to gn_length is the last column on line one times two
IF .NOT. gl_plain .AND. gn_length + 100 > ln_width
   ?? gc_heading FUNCTION "I;V"+LTRIM(STR(ln_width))
   ?
   ll_heading = .F.
ENDIF

?? "Ken's Address Book" AT 31

*-- Print HEADING parameter - if it fits on line one
IF .NOT. gl_plain .AND. gn_length > 0 .AND. ll_heading
   ?? " "
   ?? gc_heading FUNCTION "I;V"+LTRIM(STR(ln_width-(_pcolno*2)))
ENDIF
?
?? "Date: " AT 33,;
 IIF(gl_plain,'',gd_date) 
?
?
RETURN
* EOP: Pghead


PROCEDURE __Detail
IF 7 * gn_pspace < gn_atline - (_pspacing * 4 + 1)
   IF gl_widow .AND. _plineno+7 * gn_pspace > gn_atline + 1
      EJECT PAGE
   ENDIF
ENDIF
DO Upd_Vars
?? trim(first)+" "+last FUNCTION "T" PICTURE "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" AT 2
?
?? "Address:" AT 6,;
 Street FUNCTION "T" AT 15
?
?? trim(city)+", "+state+" "+zip FUNCTION "T" PICTURE "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX" AT 15
?
?? "Phone:" AT 8,;
 Phone FUNCTION "RT" PICTURE "(999) 999-9999" AT 15,;
 "Birthday:" AT 31,;
 Birthday AT 41
?
?? "Family?" AT 15,;
 iif(family,"Yes","No") FUNCTION "T" PICTURE "XXX" AT 23,;
 "Christmas Card?" AT 28,;
 iif(xmascard,"Yes","No") FUNCTION "T" PICTURE "XXX" AT 44
?
?? "Notes:" AT 8,;
 Notes FUNCTION "V60" AT 15
?
?
RETURN
* EOP: __Detail


PROCEDURE Pgfoot
PRIVATE _box, _pspacing
gl_widow=.F.         && disable widow checking
_pspacing=1
?
IF .NOT. gl_plain
   _pspacing=gn_pspace
   IF .NOT. gl_plain
   ?? "Page:" AT 36,;
    _pageno PICTURE "99" AT 42
ENDIF
ENDIF
EJECT PAGE
*-- is the page number greater than the ending page
IF _pageno > _pepage
   GOTO BOTTOM
   SKIP
   gn_level=0
ENDIF
IF .NOT. gl_plain .AND. gl_fandl
   _pspacing=gn_pspace
   DO Pghead
ENDIF
RETURN
* EOP: Pgfoot

*-- Process page break when PLAIN option is used.
PROCEDURE Pgplain
PRIVATE _box
EJECT PAGE
RETURN
* EOP: Pgplain

*-- Reset dBASE environment prior to calling report
PROCEDURE Reset
SET SPACE &gc_space.
SET TALK &gc_talk.
ON ESCAPE
ON PAGE
RETURN
* EOP: Reset

